﻿//----------------------------------------------------------------------
//
//  Test program for illustrating how to use SPI on the STM8S.  This
//  application runs on the Netduino Plus and generates a steady stream
//  of bytes counting from 0 to 254 over and over again.
//
//----------------------------------------------------------------------
using System.Threading;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoPlus;

namespace SPIMasterController
{
    public class Program
    {
        /// <summary>
        /// SPI object.
        /// </summary>
        private static SPI spi = null;

        /// <summary>
        /// Configuration of the SPI port.
        /// </summary>
        private static SPI.Configuration config = null;

        public static void Main()
        {
            config = new SPI.Configuration(SPI_mod: SPI.SPI_module.SPI1,        // Which SPI module to use?
                                           ChipSelect_Port: Pins.GPIO_PIN_D10,  // Chip select pin.
                                           ChipSelect_ActiveState: false,       // Chip select is low when SPI is active.
                                           ChipSelect_SetupTime: 0,
                                           ChipSelect_HoldTime: 0,
                                           Clock_IdleState: false,              // Clock is active low.
                                           Clock_Edge: true,                    // Sample on the rising edge.
                                           Clock_RateKHz: 500);
            spi = new SPI(config);

            byte[] buffer = new byte[17];
            for (byte index = 0; index < 17; index++)
            {
                buffer[index] = index;
            }
            while (true)
            {
                for (byte counter = 0; counter < 255; counter++)
                {
                    buffer[0] = counter;
                    spi.Write(buffer);
                    Thread.Sleep(200);
                }
            }
        }
    }
}
